#!/usr/bin/bash

if [[ -z "$1" ]]; then
    echo "Please supply a version: 0.0.0[a | b | rc-0]"
    exit
fi

set -e

cargo build --release --target x86_64-pc-windows-gnu
cargo build --release --target x86_64-unknown-linux-gnu
cargo build --release --target aarch64-unknown-linux-gnu

strip --strip-unneeded ./target/x86_64-pc-windows-gnu/release/xmpd.exe -o ./target/xmpd_win32.exe
strip --strip-unneeded ./target/x86_64-unknown-linux-gnu/release/xmpd  -o ./target/xmpd_linux_x86_64
aarch64-linux-gnu-strip --strip-unneeded ./target/aarch64-unknown-linux-gnu/release/xmpd -o ./target/xmpd_linux_aarch64
cp ./scripts/setup-template.sh  "./target/xmpd-setup-$1.sh"
cp ./scripts/setup-template.ps1 "./target/xmpd-setup-$1.ps1"
