use std::io::Write;


pub fn yes_no(p: &str, default: Option<bool>) -> bool {
    if default == Some(true) {
        println!("{c}prompt{r}: {p} (Y/n)",
            c=anstyle::AnsiColor::Cyan.render_fg(),
            r=anstyle::Reset.render()
        );
    } else if default == Some(false) {
        println!("{c}prompt{r}: {p} (y/N)",
            c=anstyle::AnsiColor::Cyan.render_fg(),
            r=anstyle::Reset.render()
        );
    } else {
        println!("{c}prompt{r}: {p} (y/n)",
            c=anstyle::AnsiColor::Cyan.render_fg(),
            r=anstyle::Reset.render()
        );
    }
    print!("> ");

    // I dont care if it fails
    let _ = std::io::stdout().flush();
    
    let mut buf = String::new();
    let _ = std::io::stdin().read_line(&mut buf);

    if buf.trim().is_empty() {
        match default {
            Some(true) => return true,
            Some(false) => return false,
            None => {
                return yes_no(p, default);
            }
        }
    }

    match buf.to_lowercase().trim() {
        "y" => true,
        "n" => false,
        c => {
            log::error!("'{c}' is invalid, type y (yes) or n (no)");
            yes_no(p, default)
        }
    }
}
