use super::Gui;


pub mod nav;
pub mod song_list;
pub mod side_nav;
pub mod search_bar;

pub trait Component {
    fn ui(gui: &mut Gui, ctx: &egui::Context);
}

pub trait ComponentUi {
    fn ui(gui: &mut Gui, ui: &mut egui::Ui);
}

pub trait ComponentUiMut {
    fn ui(&mut self, gui: &mut Gui, ui: &mut egui::Ui);
}

pub trait ComponentContextMenu {
    type Data;
    fn ui(gui: &mut Gui, ui: &mut egui::Ui, data: &Self::Data); 
}
